define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class EntityDependencyHelper {
        constructor(datastoreServiceFactory, securityService, invoker) {
            this._datastoreService = undefined;
            this._datastoreServiceFactory = undefined;
            this.securityService = undefined;
            this.invoker = undefined;
            this._datastoreServiceFactory = datastoreServiceFactory;
            this.securityService = securityService;
            this.invoker = invoker;
        }
        async getDatastoreService() {
            if (!this._datastoreService) {
                this._datastoreService = await this._datastoreServiceFactory();
            }
            return this._datastoreService;
        }
    }
    exports.EntityDependencyHelper = EntityDependencyHelper;
});

//# sourceMappingURL=entity_dependency_helper.js.map
