define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    class EntityReference {
        constructor(namespace, type, id) {
            this._namespace = undefined;
            this._type = undefined;
            this._id = undefined;
            this._namespace = namespace;
            this._type = type;
            this._id = id;
        }
        get namespace() {
            return this._namespace;
        }
        get type() {
            return this._type;
        }
        get id() {
            return this._id;
        }
        toPojo() {
            const meta = {
                isRef: true,
                type: this.type,
                namespace: this.namespace,
                isNew: false,
            };
            const data = {
                id: this.id,
                _meta: meta,
            };
            return data;
        }
    }
    exports.EntityReference = EntityReference;
});

//# sourceMappingURL=entity_reference.js.map
