import { IDataSourceAdapterConfig } from './idata_source_adapter_config';
import { EntityTypeKey, IPrivateGetOptions, IPrivateQueryOptions, IPrivateRemoveOptions, IPrivateSaveOptions } from '@essential-projects/core_contracts';
export interface IDatasourceAdapter {
    saveFullEntity: boolean;
    fullSchemaMode: boolean;
    config: IDataSourceAdapterConfig;
    query(entityTypeKey: EntityTypeKey, options?: IPrivateQueryOptions): Promise<any>;
    save(entityTypeKey: EntityTypeKey, id: string, data: any, options?: IPrivateSaveOptions): Promise<any>;
    remove(entityTypeKey: EntityTypeKey, id: string, data: any, options?: IPrivateRemoveOptions): Promise<boolean>;
    getById(entityTypeKey: EntityTypeKey, id: string, options?: IPrivateGetOptions): Promise<any>;
    checkConnection(): Promise<boolean>;
    migrate(): Promise<void>;
    initialize(): void;
    dispose(): Promise<void>;
}
