import { ExecutionContext, IEntity, IPrivateQueryOptions, IToPojoOptions } from '@essential-projects/core_contracts';
import { IEntityCollection, IEntityType } from './index';
export declare class EntityCollection<T extends IEntity> implements IEntityCollection<T> {
    private _data;
    count: number;
    offset: number;
    limit: number;
    private _options;
    private _entityType;
    constructor(entityType: IEntityType<T>, entityDataSets?: Array<any>, count?: number, offset?: number, limit?: number, options?: IPrivateQueryOptions);
    readonly data: Array<T>;
    readonly length: number;
    toPojos(context: ExecutionContext, options?: IToPojoOptions): Promise<any>;
    each(context: ExecutionContext, callback: Function): Promise<void>;
    add(entity: T, distinct?: boolean): IEntityCollection<T>;
    addCollection(context: ExecutionContext, entityCollection: IEntityCollection<T>, distinct?: boolean): Promise<IEntityCollection<T>>;
    addCollectionDistinct(context: ExecutionContext, entityCollection: IEntityCollection<T>): Promise<IEntityCollection<T>>;
    private _addCollection;
    private _loadMore;
}
