import { IEntityCollection, IEntityType } from './entity/index';
import { IGetEntityTypeKeysOptions } from './iget_entity_type_keys_options';
import { ExecutionContext, IEntity, IPublicGetOptions, IPublicQueryOptions, IPublicRemoveOptions, IPublicSaveOptions, TypeKey } from '@essential-projects/core_contracts';
export interface IDatastoreService {
    config: any;
    initialize(): Promise<void>;
    getEntityTypeKeys(options?: IGetEntityTypeKeysOptions): Array<string>;
    getEntityType<T extends IEntity>(typeName: TypeKey): Promise<IEntityType<T>>;
    getEntityTypeService(typeName: TypeKey): Promise<any>;
    getCatalog(context: ExecutionContext): any;
    getCollection<T extends IEntity>(typeName: TypeKey, context: ExecutionContext, options?: IPublicQueryOptions): Promise<IEntityCollection<T>>;
    getById<T extends IEntity>(typeName: TypeKey, id: string, context: ExecutionContext, options?: IPublicGetOptions): Promise<T>;
    updateEntity<T extends IEntity>(typeName: TypeKey, id: string, data: any, context: ExecutionContext, options?: IPublicSaveOptions): Promise<T>;
    saveNewEntity<T extends IEntity>(typeName: TypeKey, data: any, context: ExecutionContext, options?: IPublicSaveOptions): Promise<T>;
    executeEntityMethod(typeName: TypeKey, id: string, method: string, data: any, context: ExecutionContext, options?: IPublicGetOptions): Promise<any>;
    executeEntityTypeMethod(typeName: TypeKey, method: string, data: any, context: ExecutionContext, options?: IPublicGetOptions): Promise<any>;
    removeEntity(typeName: TypeKey, id: string, context: ExecutionContext, options?: IPublicRemoveOptions): Promise<void>;
    importDefaultData(context: ExecutionContext): Promise<void>;
    dispose(): Promise<void>;
}
