import { IProperties } from './iproperties';
import { ExecutionContext, IPrivateQueryOptions, ISchemaAttribute, IToPojoOptions } from '@essential-projects/core_contracts';
export interface IPropertyBag {
    propertyKeys: Array<string>;
    dirtyPropertyKeys: Array<string>;
    properties: IProperties;
    isNew: boolean;
    isDirty(): boolean;
    setupPropertyBag(): Promise<void>;
    getProperty(propertyThisContext: any, propertyName: string): any;
    getPropertyLazy(propertyThisContext: any, propertyName: string, context: ExecutionContext, options?: IPrivateQueryOptions): Promise<any>;
    setProperty(propertyThisContext: any, propertyName: string, value: any): void;
    getCalculatedProperty(propertyThisContext: any, propertyName: string, context: ExecutionContext): Promise<any>;
    setCalculatedProperty(propertyThisContext: any, propertyName: string, value: any, context: ExecutionContext): Promise<void>;
    createProperty(schema: ISchemaAttribute, propertyName: string, onInitCallback: Function): void;
    createCalculatedProperty(schema: ISchemaAttribute, propertyName: string, getCallback: Function, setCallback: Function): void;
    updateFromLocal(data: any, propertyThisContext: any): void;
    updateFromRemote(data: any): void;
    toPojo(propertyThisContext: any, context: ExecutionContext, options?: IToPojoOptions, propertyKeys?: Array<string>): Promise<any>;
}
