import { IDatastoreService, IProperty } from './../index';
import { ExecutionContext, IPrivateQueryOptions, ISchemaAttribute } from '@essential-projects/core_contracts';
import { IFactoryAsync } from 'addict-ioc';
export declare class Property implements IProperty {
    private _schema;
    private _datastoreServiceFactory;
    private _datastoreService;
    private _context;
    private _onInitCallback;
    private _remoteValue;
    private _value;
    constructor(schema: ISchemaAttribute, datastoreServiceFactory: IFactoryAsync<IDatastoreService>, context: ExecutionContext, onInitCallback: Function);
    readonly schema: ISchemaAttribute;
    private getDatastoreService;
    private readonly context;
    private readonly onInitCallback;
    private remoteValue;
    private value;
    isDirty(): boolean;
    isEntity(): boolean;
    isEntityReference(): boolean;
    isEntityCollectionReference(): boolean;
    initializeValue(): Promise<void>;
    getValue(valueSource: any): any;
    private _buildEntityCollectionByReferenceQuery;
    getValueLazy(valueSource: any, context: ExecutionContext, options?: IPrivateQueryOptions): Promise<any>;
    setValue(valueTarget: any, value: any): void;
    updateFromRemote(remoteValue: any): void;
    private _getCurrentValue;
    private _isEntity;
    private _isEntityReference;
    private _isEntityCollectionReference;
    private _getEntityByReference;
    private _getEntityCollectionByReference;
}
