import { ExecutionContext, IPrivateQueryOptions, ISchemaAttribute, IToPojoOptions } from '@essential-projects/core_contracts';
import { IMetadataProvider } from '@essential-projects/metadata_contracts';
import { IFactoryAsync } from 'addict-ioc';
import { IDatastoreService, IProperties, IPropertyBag } from './../index';
export declare class PropertyBag implements IPropertyBag {
    private _datastoreServiceFactory;
    private _metadataProvider;
    private _context;
    private _properties;
    private _propertyChangedCallbacks;
    isNew: boolean;
    constructor(datastoreServiceFactory: IFactoryAsync<IDatastoreService>, metadataProvider: IMetadataProvider, context: ExecutionContext);
    private readonly datastoreServiceFactory;
    private readonly metadataProvider;
    private readonly context;
    readonly properties: IProperties;
    private readonly propertyChangedCallbacks;
    readonly propertyKeys: Array<string>;
    readonly dirtyPropertyKeys: Array<string>;
    setupPropertyBag(): Promise<void>;
    private _pojofyEntityCollectionProperty;
    private _pojofyResolvedEntityProperty;
    private _pojofyEntityProperty;
    private _pojofyComplexType;
    private _exportProperty;
    toPojo(propertyThisContext: any, context: ExecutionContext, options?: IToPojoOptions, propertyKeys?: Array<string>): Promise<any>;
    isDirty(): boolean;
    private _getProperty;
    private _setProperty;
    getProperty(propertyThisContext: any, propertyName: string): any;
    getPropertyLazy(propertyThisContext: any, propertyName: string, context: ExecutionContext, options?: IPrivateQueryOptions): Promise<any>;
    setProperty(propertyThisContext: any, propertyName: string, value: any): void;
    getCalculatedProperty(propertyThisContext: any, propertyName: string, context: ExecutionContext): Promise<any>;
    setCalculatedProperty(propertyThisContext: any, propertyName: string, value: any, context: ExecutionContext): Promise<void>;
    createProperty(schema: ISchemaAttribute, propertyName: string, onInitCallback: Function): void;
    createCalculatedProperty(schema: ISchemaAttribute, propertyName: string, getCallback: Function, setCallback: Function): void;
    updateFromLocal(data: any, propertyThisContext: any): void;
    updateFromRemote(data: any): void;
    private _setPropertyValues;
}
