'use strict';

const PropertyBag = require('./dist/commonjs/index').PropertyBag;
const EntityDependencyHelper = require('./dist/commonjs/index').EntityDependencyHelper;

function registerInContainer(container, useCustomEncryptionService) {

  container.register('PropertyBag', PropertyBag)
    .dependencies('DatastoreService', 'MetadataProvider')
    .injectPromiseLazy('DatastoreService');

  container.register('EntityDependencyHelper', EntityDependencyHelper)
    .dependencies('DatastoreService', 'SecurityService', 'Invoker')
    .injectPromiseLazy('DatastoreService')
    .singleton();
}

module.exports.registerInContainer = registerInContainer;
