import {
  IEntity,
  IPrivateGetOptions,
  IPrivateQueryOptions,
  IPrivateRemoveOptions,
  IPrivateSaveOptions
} from '@essential-projects/core_contracts';

export interface IDataSource<T extends IEntity> {
  saveFullEntity: boolean;
  fullSchemaMode: boolean;
  query(options?: IPrivateQueryOptions): Promise<any>;
  save(id: string, data: T, options?: IPrivateSaveOptions): Promise<boolean>;
  remove(id: string, options?: IPrivateRemoveOptions): Promise<boolean>;
  getById(id: string, options?: IPrivateGetOptions): Promise<T>;
  checkConnection(): Promise<boolean>;
  initialize(): void;
  dispose(): Promise<void>;
}
