import {ExecutionContext, IEntity, IToPojoOptions} from '@essential-projects/core_contracts';

export interface IEntityCollection<T extends IEntity> {
  data: Array<T>;
  length: number;
  toPojos(context: ExecutionContext, options?: IToPojoOptions): Promise<any>;
  each(context: ExecutionContext, callback: Function): Promise<void>;
  add(entity: T, distinct?: boolean): IEntityCollection<T>;
  addCollection(context: ExecutionContext, entityCollection: IEntityCollection<T>, distinct?: boolean): Promise<IEntityCollection<T>>;
  addCollectionDistinct(context: ExecutionContext, entityCollection: IEntityCollection<T>): Promise<IEntityCollection<T>>;
}
