import { IEntityCollectionReference, TypeKey } from '@essential-projects/core_contracts';

export class EntityCollectionReference implements IEntityCollectionReference {

  private _namespace: string = undefined;
  private _type: TypeKey = undefined;
  private _relatedType: TypeKey = undefined;
  private _relatedAttribute: string = undefined;
  private _id: string = undefined;
  public resolve: boolean = false;

  constructor(namespace: string, type: TypeKey, id: string, relatedType: TypeKey, relatedAttribute: string, resolve?: boolean) {
    this._namespace = namespace;
    this._type = type;
    this._id = id;
    this._relatedType = relatedType;
    this._relatedAttribute = relatedAttribute;
    if (resolve) {
      this.resolve = resolve;
    }
  }

  public get namespace(): string {
    return this._namespace;
  }

  public get type(): TypeKey {
    return this._type;
  }

  public get id(): string {
    return this._id;
  }

  public get relatedType(): TypeKey {
    return this._relatedType;
  }

  public get relatedAttribute(): string {
    return this._relatedAttribute;
  }

  public toPojo(): any {
    const data: any = {
      id: this.id,
      _meta: {
        isCollectionRef: true,
        type: this.type,
        namespace: this.namespace,
        relatedType: this.relatedType,
        relatedAttribute: this.relatedAttribute,
      },
    };

    return data;
  }
}
