import {IInvoker} from '@essential-projects/invocation_contracts';
import { ISecurityService } from '@essential-projects/security_service_contracts';
import {IFactoryAsync} from 'addict-ioc';
import {IDatastoreService, IEntityDependencyHelper} from './index';

export class EntityDependencyHelper implements IEntityDependencyHelper {

  private _datastoreService: IDatastoreService = undefined;
  private _datastoreServiceFactory: IFactoryAsync<IDatastoreService> = undefined;

  public securityService: ISecurityService = undefined;
  public invoker: IInvoker = undefined;

  constructor(datastoreServiceFactory: IFactoryAsync<IDatastoreService>, securityService: ISecurityService, invoker: IInvoker) {
    this._datastoreServiceFactory = datastoreServiceFactory;
    this.securityService = securityService;
    this.invoker = invoker;
  }

  public async getDatastoreService(): Promise<IDatastoreService> {
    if (!this._datastoreService) {
      this._datastoreService = await this._datastoreServiceFactory();
    }

    return this._datastoreService;
  }
}
