import { IEntityReference, IPojoEntityReference, IPojoMetadata, TypeKey} from '@essential-projects/core_contracts';

export class EntityReference implements IEntityReference {

  private _namespace: string = undefined;
  private _type: TypeKey = undefined;
  private _id: string = undefined;

  constructor(namespace: string, type: TypeKey, id: string) {
    this._namespace = namespace;
    this._type = type;
    this._id = id;
  }

  public get namespace(): string {
    return this._namespace;
  }

  public get type(): TypeKey {
    return this._type;
  }

  public get id(): string {
    return this._id;
  }

  public toPojo(): IPojoEntityReference {
    const meta: IPojoMetadata = {
      isRef: true,
      type: this.type,
      namespace: this.namespace,
      isNew: false,
    };

    const data: IPojoEntityReference = {
      id: this.id,
      _meta: meta,
    };

    return data;
  }
}
