import {EntityTypeKey, IAllSchemas, IGetSchemasOptions, IInheritedSchema, ISchema, TypeKey} from '@essential-projects/core_contracts';

export interface ISchemaProvider {
  getNamespaces(): Array<string>;
  getKeys(namespace?: string): Array<EntityTypeKey>;
  getAllSchemas(namespace?: string, options?: IGetSchemasOptions): IAllSchemas;
  getOwnSchemasRecursivelyBaseFirst(typeName: EntityTypeKey,
                                    namespace?: string,
                                    options?: IGetSchemasOptions,
                                    currentSchemas?: Array<ISchema>): Array<ISchema>;
  getOwnSchemaRecursively(entityKey: EntityTypeKey, namespace?: string, options?: IGetSchemasOptions): IInheritedSchema;
  getOwnSchema(key: EntityTypeKey, namespace?: string): ISchema;
  getParentEntityKey(namespace: string, entityKey: EntityTypeKey): EntityTypeKey;
  findType(type: TypeKey, namespace?: string): string;
  register(key: EntityTypeKey, schema: any, namespace?: string): void;
  initialize(): void;
}
